import logging
from event_handler_base import EventHandlerBase
from tornado.ioloop import IOLoop
from tornado.web import Application
from terminado import TermSocket, SingleTermManager


class CORSTermSocket(TermSocket):
    def check_origin(self, origin):
        return True


class TerminadoEventHandler(EventHandlerBase):
    def __init__(self, anchor, zmq_context=None):
        super().__init__(anchor, zmq_context)

    def handle_event(self, anchor, data_json):
        raise NotImplementedError   # TODO: wat do?


if __name__ == '__main__':
    application = Application(
        [(
            r'/terminal',
            CORSTermSocket,
            {'term_manager': SingleTermManager(shell_command=['bash'])}
        )]
    )
    HOST, PORT = 'localhost', 7878
    application.listen(PORT, HOST)
    logging.getLogger().setLevel(logging.DEBUG)
    logging.info('Terminado Mini Server listening on {}:{}'.format(HOST, PORT))
    IOLoop.instance().start()
